package com.ruoyi.ems.service.impl;

import com.ruoyi.ems.domain.PlantCarbonSink;
import com.ruoyi.ems.mapper.PlantCarbonSinkMapper;
import com.ruoyi.ems.service.IPlantCarbonSinkService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

/**
 * 植物碳汇配置Service业务层处理
 *
 * @author ruoyi
 * @date 2025-11-12
 */
@Service
public class PlantCarbonSinkServiceImpl implements IPlantCarbonSinkService {
    @Autowired
    private PlantCarbonSinkMapper plantCarbonSinkMapper;

    /**
     * 查询植物碳汇配置
     *
     * @param id 植物碳汇配置主键
     * @return 植物碳汇配置
     */
    @Override
    public PlantCarbonSink selectById(Long id) {
        return plantCarbonSinkMapper.selectById(id);
    }

    /**
     * 查询植物碳汇配置列表
     *
     * @param param 植物碳汇配置
     * @return 植物碳汇配置
     */
    @Override
    public List<PlantCarbonSink> selectList(PlantCarbonSink param) {
        return plantCarbonSinkMapper.selectList(param);
    }

    @Override
    public List<PlantCarbonSink> getAreaCfg(String areaCode) {
        return plantCarbonSinkMapper.selectAreaCfg(areaCode);
    }

    @Override
    public void mergeAreaCfg(String areaCode, List<PlantCarbonSink> list) {
        plantCarbonSinkMapper.deleteAreaCfg(areaCode);

        if (CollectionUtils.isNotEmpty(list)) {
            plantCarbonSinkMapper.addAreaCfgBatch(list);
        }
    }

    /**
     * 新增植物碳汇配置
     *
     * @param param 植物碳汇配置
     * @return 结果
     */
    @Override
    public int insert(PlantCarbonSink param) {
        return plantCarbonSinkMapper.insert(param);
    }

    /**
     * 修改植物碳汇配置
     *
     * @param param 植物碳汇配置
     * @return 结果
     */
    @Override
    public int update(PlantCarbonSink param) {
        return plantCarbonSinkMapper.update(param);
    }

    /**
     * 删除植物碳汇配置信息
     *
     * @param id 植物碳汇配置主键
     * @return 结果
     */
    @Override
    public int deleteById(Long id) {
        return plantCarbonSinkMapper.deleteById(id);
    }
}
